ansible: Install gcc-4.8 on Debian compiler nodes
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
97# Find the most recent GCC version supported by the kernel sources
98select_compiler() {
99 local selected_cc
100
101 cd "$LINUX_SRCOBJ_DIR"
102
103 kversion=$(make -s kernelversion)
104
105 set +e
106
2456f978 107 for cc in gcc-8 gcc-5 gcc-4.8; do
5a196804
MJ
108 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
109 selected_cc="$cc"
110 break
111 fi
112 done
113
114 set -e
115
116 if [ "x$selected_cc" = "x" ]; then
117 echo "Found no suitable compiler."
118 exit 1
119 fi
120
1d5a0a3c
MJ
121 # Force gcc-4.8 for kernels before 3.18
122 if { verlt "$kversion" "3.18"; }; then
23db2292 123 selected_cc=gcc-4.8
7e02032c
MJ
124 fi
125
425e4992
MJ
126 if [ "$selected_cc" != "gcc-4.8" ]; then
127 # Older kernel Makefiles do not expect the compiler to default to PIE
128 KAFLAGS="-fno-pie"
c45b04df 129 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
130 KCPPFLAGS="-fno-pie"
131 export KAFLAGS KCFLAGS KCPPFLAGS
132 fi
133
5a196804 134 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 135 export HOSTCC="${selected_cc}"
5a196804
MJ
136
137 cd -
138}
139
140
141build_linux_kernel() {
142 cd "$LINUX_SRCOBJ_DIR"
143
144 kversion=$(make -s kernelversion)
145
7e02032c 146 # Generate kernel configuration
a1ae361e 147 case "$ktag" in
7e02032c 148 Ubuntu*)
39961776 149 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 150 if vergte "${kversion}" "4.10"; then
39961776
MJ
151 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
152 exit 0
153 fi
154 fi
af101606
MJ
155
156 # Disable riscv64 config generation, we don't have a toolchain on bionic
157 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
158
073dc82c
MJ
159 # Hack for kernel Ubuntu-hwe-5.8
160 if [ ! -f "debian/compat" ]; then
161 echo "10" > "debian/compat"
162 fi
163
a46abb0a
MJ
164 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
165 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 166 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 167 ;;
c45b04df 168
7e02032c 169 *)
16844a6d
MJ
170 # Force 32bit build on i386, default is 64bit
171 if [ "$arch" = "i386" ]; then
5a196804
MJ
172 export ARCH="i386"
173 fi
174
175 # allyesconfig is mostly broken for kernels of the 2.6 series
176 if verlt "$kversion" "3.0"; then
177 vanilla_config="defconfig"
7a76a4d0
MJ
178 fi
179
5a196804 180 make "${vanilla_config}"
7e02032c
MJ
181 ;;
182 esac
183
53b51a15 184 # oldnoconfig was renamed in 4.19
5a196804 185 if vergte "$kversion" "4.19"; then
53b51a15 186 update_conf_target="olddefconfig"
5a196804 187 else
53b51a15 188 update_conf_target="oldnoconfig"
5a196804
MJ
189 fi
190
191 # Fix 'defined(@array)' was removed from recent perl
192 if [ -f "kernel/timeconst.pl" ]; then
193 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
194 fi
195
196 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 197 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
198 if [ -f "arch/x86/kvm/svm.c" ]; then
199 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
200 fi
201
202 if [ -f "arch/x86/kvm/vmx.c" ]; then
203 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
204 fi
205 fi
206
53b51a15
MJ
207 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
208 # Convert them to 'cmpw' which was previously done silently
209 if verlt "$kversion" "4.9"; then
210 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
211 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
212 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
213 fi
214
5a196804
MJ
215 # Fix a typo in v2.6.36.x
216 if [ -f "arch/x86/kernel/entry_64.S" ]; then
217 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
218 fi
219
53b51a15
MJ
220 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
221 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
222 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
223 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
224 fi
225
5a196804
MJ
226 # Fix kernel < 3.0 with gcc >= 4.7
227 if verlt "$kversion" "3.0"; then
228 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
229 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
230 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
231 echo "header-y += linkage.h" >> include/linux/Kbuild
232 fi
233
7e02032c 234 # GCC 4.8
53b51a15
MJ
235 if [ "$HOSTCC" == "gcc-4.8" ]; then
236 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
237 fi
7e02032c
MJ
238
239 # Don't try to sign modules
53b51a15 240 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 241
9ef18fa2 242 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 243 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
244
245 # Cause problems with inline assembly on i386
53b51a15 246 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 247
1d5a0a3c 248 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
249 scripts/config --disable CONFIG_SAMPLES
250 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
251
252 # Disable kcov
53b51a15 253 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
254
255 # Broken on some RT kernels
53b51a15 256 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 257
1e300ea9 258 # Broken drivers
53b51a15
MJ
259 scripts/config --disable CONFIG_RAPIDIO_TSI721
260 scripts/config --disable CONFIG_SGI_XP
261 scripts/config --disable CONFIG_MFD_WM8994
262 scripts/config --disable CONFIG_DRM_RADEON
263 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 264
5a196804
MJ
265 # IGBVF won't build with recent gcc on 2.6.38.x
266 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 267 scripts/config --disable CONFIG_IGBVF
5a196804 268 fi
9ef18fa2 269
c72041eb
MJ
270 # Don't fail the build on warnings
271 scripts/config --disable CONFIG_WERROR
272
51fa2ab3 273 # Set required options
53b51a15
MJ
274 scripts/config --enable CONFIG_TRACEPOINTS
275 scripts/config --enable CONFIG_KALLSYMS
276 scripts/config --enable CONFIG_HIGH_RES_TIMERS
277 scripts/config --enable CONFIG_KPROBES
278 scripts/config --enable CONFIG_FTRACE
279 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
280 scripts/config --enable CONFIG_KALLSYMS_ALL
281 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
282 scripts/config --enable CONFIG_PERF_EVENTS
283 scripts/config --enable CONFIG_EVENT_TRACING
284 scripts/config --enable CONFIG_KRETPROBES
7e02032c 285
1d28ffce
MJ
286 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
287 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
81e61c58
MJ
288 # Starting with v6.1-rc6
289 sed -i 's/^objtool-enabled := .*/objtool-enabled := /' scripts/Makefile.vmlinux_o || true
1d28ffce 290
ba1a68bc
MJ
291 # Disable SORTTAB
292 sed -i 's/is_enabled CONFIG_BUILDTIME_TABLE_SORT/is_enabled CONFIG_NONEXISTANT/' scripts/link-vmlinux.sh || true
293
7a76a4d0 294 # Debug
5a196804
MJ
295 #cat .config
296
297 make "$update_conf_target" CC="$CC"
298 make -j"$NPROC" CC="$CC"
299
c45b04df 300 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
301
302 # Save the kernel and modules
303 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 304 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 305 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
306 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
307 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
308 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
309}
310
311
312extract_distro_headers() {
313
314 # Enter linux source dir
315 cd "${LINUX_SRCOBJ_DIR}"
316
317
318 # For RT kernels, copy version file
319 if [ -s localversion-rt ]; then
320 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
321 fi
322
323 # Copy all Makefile related stuff
324 find . -path './include/*' -prune \
325 -o -path './scripts/*' -prune -o -type f \
326 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
327 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
328 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
329
330 # Copy base scripts and include dirs
331 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 332
5a196804
MJ
333 # Copy arch includes
334 (find arch -name include -type d -print0 | \
335 xargs -0 -n1 -i: find : -type f) | \
336 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
337
338 # Copy arch scripts
339 (find arch -name scripts -type d -print0 | \
340 xargs -0 -n1 -i: find : -type f) | \
341 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
342
343 # Cleanup scripts
344 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
345 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
346
04873cc3 347 # On powerpc 32bits this object is required to link modules
5a196804 348 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
349 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
350 :
351 else
04873cc3
MJ
352 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
353 fi
5a196804
MJ
354 fi
355
356 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
357 if [ "${karch}" = "arm64" ]; then
358 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
359 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
360 fi
361 fi
362
363 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
364 if [ -f tools/objtool/objtool ]; then
365 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
366 fi
367
368 if [ -f "arch/x86/kernel/macros.s" ]; then
369 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
370 fi
371
372 # Copy modules related stuff, if available
373 if [ -s Module.symvers ]; then
374 cp Module.symvers "${LINUX_HDROBJ_DIR}"
375 fi
376
377 if [ -s System.map ]; then
378 cp System.map "${LINUX_HDROBJ_DIR}"
379 fi
380
381 if [ -s Module.markers ]; then
382 cp Module.markers "${LINUX_HDROBJ_DIR}"
383 fi
384
385 # Copy config file
386 cp .config "${LINUX_HDROBJ_DIR}"
387
388 # Make sure the Makefile and version.h have a matching timestamp so that
389 # external modules can be built
390 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
391 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
392 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
393 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
394 else
395 echo "Missing version.h"
396 exit 1
397 fi
398 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
399
400 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
401 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
402 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
403 fi
5a196804
MJ
404
405 # Finally clean the object files from the full source tree
406 make clean
407
408 # And regen the modules support files
409 make modules_prepare CC="$CC"
51fa2ab3 410
04873cc3 411 # On powerpc 32bits this object is required to link modules
d815b018 412 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
413 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
414 :
415 else
04873cc3
MJ
416 make arch/powerpc/lib/crtsavres.o CC="$CC"
417 fi
d815b018
MJ
418 fi
419
7a76a4d0 420 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 421 if [ "${karch}" = "arm64" ]; then
c236528e 422 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 423 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
424 fi
425 fi
426
7e02032c 427 # Version specific tasks
a1ae361e 428 case "$ktag" in
7e02032c
MJ
429 Ubuntu*)
430 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 431 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
432 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
433 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
434 ;;
435 esac
7e02032c
MJ
436}
437
438
339db64d
MJ
439build_modules() {
440
5a196804
MJ
441 local kdir="$1"
442 local outdir="$2"
443 local kversion
444
445 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 446
2456f978
MJ
447 # Try to catch some compatibility problems by turning some
448 # warnings into errors.
999a2aa0 449 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 450
339db64d 451 # Enter lttng-modules source dir
5a196804 452 cd "${MODULES_GIT_DIR}"
339db64d
MJ
453
454 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
455 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
456 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
457 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
458
459 set +e
460
461 # Build modules
51fa2ab3 462 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 463 ret=$?
339db64d 464
5a196804
MJ
465 set -e
466
339db64d 467 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 468 if [ "$ret" -eq 0 ]; then
e9b44189 469 echo "This build should have failed."
339db64d
MJ
470 exit 1
471 fi
472
473 # We have to publish at least one file or the build will fail
5a196804 474 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 475
5a196804 476 KERNELDIR="${kdir}" make clean
7e02032c 477
339db64d
MJ
478 else # Regular build
479
480 # Build modules against full kernel sources
51fa2ab3 481 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
482
483 # Install modules to build dir
5a196804 484 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
485
486 # Clean build dir
5a196804 487 KERNELDIR="${kdir}" make clean
339db64d
MJ
488 fi
489}
490
491
492## MAIN ##
493
f3d8604b
MJ
494# Use all CPU cores
495NPROC=$(nproc)
496
5a196804
MJ
497MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
498LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 499
5a196804
MJ
500LINUX_OBJ_DIR="${WORKSPACE}/linux"
501LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
502LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
503LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 504
5a196804
MJ
505MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
506MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 507
5a196804
MJ
508LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
509
510OBJ_STORE_URL="s3://jenkins"
511
512cd "$WORKSPACE"
513
514# Create build directories
515mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
516
517git_clone_modules_sources
339db64d 518
7e02032c 519# Setup cross compile env if available
39961776 520if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
521
522 case "$cross_arch" in
523 "armhf")
524 karch="arm"
525 cross_compile="arm-linux-gnueabihf-"
53b51a15 526 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
527 ubuntu_config="armhf-config.flavour.generic"
528 ;;
529
530 "arm64")
531 karch="arm64"
532 cross_compile="aarch64-linux-gnu-"
53b51a15 533 vanilla_config="defconfig"
7e02032c
MJ
534 ubuntu_config="arm64-config.flavour.generic"
535 ;;
536
537 "powerpc")
538 karch="powerpc"
539 cross_compile="powerpc-linux-gnu-"
e9b44189 540 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
541 ubuntu_config="powerpc-config.flavour.powerpc-smp"
542 ;;
543
544 "ppc64el")
545 karch="powerpc"
546 cross_compile="powerpc64le-linux-gnu-"
e9b44189 547 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
548 ubuntu_config="ppc64el-config.flavour.generic"
549 ;;
550
551 *)
51fa2ab3 552 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
553 exit 1
554 ;;
555 esac
339db64d 556
7e02032c
MJ
557 # Export variables used by Kbuild for cross compilation
558 export ARCH="${karch}"
559 export CROSS_COMPILE="${cross_compile}"
339db64d 560
7e02032c 561# Set arch specific values if we are not cross compiling
39961776 562elif [ "x${arch}" != "x" ]; then
e9b44189 563
7e02032c 564 case "$arch" in
16844a6d 565 "i386")
7e02032c 566 karch="x86"
e9b44189 567 vanilla_config="allyesconfig"
7e02032c
MJ
568 ubuntu_config="i386-config.flavour.generic"
569 ;;
570
16844a6d 571 "amd64")
7e02032c 572 karch="x86"
e9b44189 573 vanilla_config="allyesconfig"
7e02032c
MJ
574 ubuntu_config="amd64-config.flavour.generic"
575 ;;
576
577 "armhf")
578 karch="arm"
e9b44189 579 vanilla_config="allyesconfig"
7e02032c
MJ
580 ubuntu_config="armhf-config.flavour.generic"
581 ;;
582
583 "arm64")
584 karch="arm64"
e9b44189 585 vanilla_config="allyesconfig"
7e02032c
MJ
586 ubuntu_config="arm64-config.flavour.generic"
587 ;;
588
589 "powerpc")
590 karch="powerpc"
e9b44189 591 vanilla_config="allyesconfig"
7e02032c
MJ
592 ubuntu_config="powerpc-config.flavour.powerpc-smp"
593 ;;
594
595 "ppc64el")
596 karch="powerpc"
e9b44189 597 vanilla_config="allyesconfig"
7e02032c
MJ
598 ubuntu_config="ppc64el-config.flavour.generic"
599 ;;
600
601 *)
602 echo "Unsupported arch $arch"
603 exit 1
604 ;;
605 esac
606else
04873cc3 607 echo "No arch or cross_arch specified"
7e02032c
MJ
608 exit 1
609fi
339db64d 610
339db64d 611
b214d997 612
5a196804
MJ
613# First get the kernel build from the object store, or build it, if it's
614# not available.
339db64d 615
5a196804
MJ
616echo "# Setup endpoint
617host_base = obj.internal.efficios.com
618host_bucket = obj.internal.efficios.com
619bucket_location = us-east-1
620use_https = True
7e02032c 621
5a196804
MJ
622# Setup access keys
623access_key = jenkins
624secret_key = echo123456
339db64d 625
5a196804
MJ
626# Enable S3 v4 signature APIs
627signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 628
c45b04df 629url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 630obj_name="linux.tar.bz2"
87445931
MJ
631
632if [ "x${cross_arch}" = "x" ]; then
633 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
634else
635 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
636fi
637
5a196804 638obj_url="$obj_url_prefix/$obj_name"
339db64d 639
5a196804
MJ
640set +e
641s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
642ret=$?
643set -e
339db64d 644
5a196804
MJ
645case "$ret" in
646 "0")
647 extract_archive_obj
648 ;;
a1ae361e 649
5a196804
MJ
650 "12")
651 echo "File not found"
339db64d 652
5a196804
MJ
653 # Build all the things and upload
654 # then finish the module build...
339db64d 655
5a196804
MJ
656 git_clone_linux_sources
657 git_export_linux_sources
339db64d 658
5a196804 659 select_compiler
a1ae361e 660
5a196804
MJ
661 ## PREPARE FULL LINUX SOURCE TREE
662 build_linux_kernel
d138fc44 663
5a196804
MJ
664 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
665 extract_distro_headers
339db64d 666
5a196804 667 tar_archive_obj
339db64d 668
5a196804 669 upload_archive_obj
339db64d 670
5a196804 671 ;;
339db64d 672
5a196804
MJ
673 *)
674 echo "Unknown error? Abort"
675 exit 1
676 ;;
677esac
339db64d 678
5a196804 679select_compiler
f3d8604b 680
7e02032c 681## BUILD modules
5a196804
MJ
682# Either we downloaded a pre-build kernel or we built it and uploaded
683# the archive for future builds.
684
685cd "$WORKSPACE"
f3d8604b 686
339db64d 687# Build modules against full kernel sources
5a196804 688build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 689
339db64d 690# Build modules against kernel headers
5a196804 691build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 692
5a196804
MJ
693# Make sure some modules were actually built
694tree "${MODULES_OUTPUT_KSRC_DIR}"
695if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
696 echo "No modules built!"
697 exit 1
698fi
699
5a196804
MJ
700tree "${MODULES_OUTPUT_KHDR_DIR}"
701if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
702 echo "No modules built!"
703 exit 1
704fi
b214d997 705
f3d8604b 706# EOF
This page took 0.06343 seconds and 4 git commands to generate.